<template>
  <Container class="w-full">
    <SectionHeader icon="mdi-phone-outline">
      Номера телефонов
    </SectionHeader>

    <section class="mt-4">
      <CreateGuestPhoneForm @create="$data => emit('create:phone', $data)" />
    </section>

    <EmptyState
      v-if="!phones.length"
      embedded
      class="mt-4 py-8 bg-gray-50"
    />

    <v-list
      v-show="phones.length"
      lines="two"
      class="mt-4"
    >
      <v-slide-y-transition
        group
        leave-absolute
      >
        <v-list-item
          v-for="(phone, index) in phones"
          :key="phone.id"
          :class="{ 'bg-gray-50': index % 2 === 0 }"
        >
          <template #prepend>
            <v-btn
              v-tooltip:top-start="{ text: 'Нажмите, чтобы позвонить', openOnClick: true }"
              icon="mdi-phone"
              :href="getTelHref(phone.value)"
              variant="tonal"
              size="small"
              class="text-teal-600 mr-4"
            />
          </template>

          <template #title>
            {{ getFormattedPhoneNumber(phone.value) }}
          </template>

          <template #subtitle>
            Добавлен {{ dt.display(phone.createdAt) }}
          </template>

          <template #append>
            <DeleteGuestPhoneForm
              :phone="phone"
              @delete="$phoneId => emit('delete:phone', $phoneId)"
            />
          </template>
        </v-list-item>
      </v-slide-y-transition>
    </v-list>
  </Container>
</template>

<script setup lang="ts">
import { computed } from 'vue';

import { getFormattedPhoneNumber } from '@/utils';
import { useDateTime } from '@/composables';

import EmptyState from '@/components/layout/EmptyState.vue';
import Container from '@/components/layout/Container.vue';
import SectionHeader from '@/components/layout/SectionHeader.vue';

import CreateGuestPhoneForm from './CreateGuestPhoneForm.vue';
import DeleteGuestPhoneForm from './DeleteGuestPhoneForm.vue';

const props = defineProps<{ phones: IGuest['phones'] }>();
const emit = defineEmits(['create:phone', 'delete:phone']);

const dt = useDateTime();

const phones = computed(() => {
  return props.phones.toSorted((phoneA, phoneB) => {
    return (
      dt.wrap(phoneB.createdAt).toMillis() -
      dt.wrap(phoneA.createdAt).toMillis()
    );
  });
});

const getTelHref = (phone: string) => `tel:${phone}`;
</script>